CovidConsult/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
import homepage.urls as homepage
import forum.urls as forum
import authentication.urls as authentication
import consultation.urls as consultation
import article.urls as article
import obatpedia.urls as obatpedia
import profilepage.urls as profilepage

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include(homepage)),
    path('forum/', include(forum)),
    path('accounts/', include(authentication)),
    path('article/',include(article)),
    path('consultation/', include(consultation)),
    path('obatpedia/', include(obatpedia)),
    path('apis/', include('apis.urls')), 
    path('profile/', include(profilepage))
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

apis/urls.py
from django.urls import path

from .views import ListForum, DetailForum

urlpatterns = [
    path('forum/', ListForum.as_view()),
    path('forum/<int:pk>/', DetailForum.as_view()) 
]

authentication/urls.py
from django.urls import path
from .views import signup, login_user, logout_user, handle_signup, login_flutter, signup_flutter, logout_Flutter

app_name = 'authentication'

urlpatterns = [
    path('signup/', signup, name="SignUp"),
    path('signupAjax/', handle_signup, name="SignUpAjax"),
    path('login/', login_user, name="Login"),
    path('loginFlutter', login_flutter, name="LoginFlutter"),
    path('signupFlutter', signup_flutter, name="LoginFlutter"),
    path('logoutFlutter', logout_Flutter, name="LoginFlutter"),
    path('logout/', logout_user, name="Logout"),
]

forum/urls.py
from django.urls import path

from . import views

app_name = 'forum'

urlpatterns = [
    path('', views.forum, name='forum1'),
    path('category/<str:category>/', views.forum, name='forum2'),
    path('category/<str:category>/search/', views.search),
    path('posts/<int:pk>/', views.readForum, name='readForum'),
    
    path('addPost/', views.editPost, name='addPost'),
    path('addReply/<int:pkC>/', views.editReply, name='addReply'),

    path('editPost/<int:pk>/', views.editPost, name='editPost'),
    path('editComment/<int:pk>/', views.editComment, name='editComment'),
    path('editReply/<int:pkC>/<int:pkR>/', views.editReply, name='editReply'),
    
    path('deletePost/<int:pk>/', views.deletePost, name='deletePost'),
    path('deleteComment/<int:pk>/', views.deleteComment, name='deleteComment'),
    path('deleteReply/<int:pk>/', views.deleteReply, name='deleteReply'),
    
    path('profil/<str:username>/', views.profil, name='profil'),
    
    path('confirmDeletePost/<int:pk>/', views.confirmDeletePost, name='confirmDeletePost'),
    path('confirmDeleteComment/<int:pk>/', views.confirmDeleteComment, name='confirmDeleteComment'),
    path('confirmDeleteReply/<int:pk>/', views.confirmDeleteReply, name='confirmDeleteReply'),
    
    path('search/', views.search),

    path('commentForum/<int:pk>/', views.getCommentForum, name='commentForum'),
    path('replyCommentForum/<int:pk>/', views.getReplyForum, name='replyCommentForum'),
    path('api/<str:category>/', views.getCategoryForum, name='getCategoryForum'),
    path('getNum/', views.getNum, name='getNum'),
    
    path('postNewForum/', views.postNewForum, name='postNewForum'),
    path('commentNewForum/<int:pk>/', views.commentNewForum, name='commentNewForum'),
    path('replyCommentNewForum/<int:pk>/', views.replyCommentNewForum, name='replyCommentNewForum'), 
]

forum/models.py
from django.db import models
from django.contrib.auth.models import User
from django.utils.timezone import now
from datetime import datetime, date

KATEGORI = (
    ('', '*Choose Category Discussion*'),
    ('general', 'General Discussion'),
    ('covid', 'Covid Info'),
    ('drug', 'Drug Info'),
)

class Post(models.Model):
    judul = models.CharField(max_length = 150)
    kategori = models.CharField(max_length = 25, choices = KATEGORI, default='')
    isi = models.TextField()
    """
    When the referenced object is deleted, 
    also delete the objects that have references
    to it (when you remove a blog post for instance, 
    you might want to delete comments as well)
    """
    penulis = models.ForeignKey(User, on_delete = models.CASCADE,blank=True, null=True)
    DateTime = models.DateTimeField(default=now)
    warna = models.CharField(max_length = 10,default='#bcbcbc')
    strings = models.TextField()
    namaPenulis = models.CharField(max_length = 50, default='')

    @property
    def num_posts(self):
        return Post.objects.filter(kategori=self).count()
    
class Color(models.Model):
    # Many-to-one relationships
    user = models.ForeignKey(User, on_delete = models.CASCADE)
    colorHex = models.CharField(max_length = 10,blank=True,default='#bcbcbc')
    
class Comment(models.Model):
    isi = models.TextField()
    post = models.ForeignKey(Post, on_delete = models.CASCADE)
    penulis = models.ForeignKey(User, on_delete = models.CASCADE)
    namaPenulis = models.CharField(max_length = 50, default='')
    DateTime = models.DateTimeField(default=now)
    jumlahReply = models.CharField(max_length = 100)
    warna = models.CharField(max_length = 10,default='#bcbcbc')
    
class ReplyComment(models.Model):
    isi = models.TextField()
    penulis = models.ForeignKey(User, on_delete = models.CASCADE)
    namaPenulis = models.CharField(max_length = 50, default='')
    komen = models.ForeignKey(Comment, on_delete = models.CASCADE)
    targetBalasan = models.ForeignKey('self', on_delete = models.CASCADE, null=True)
    DateTime = models.DateTimeField(default=now)
    warna = models.CharField(max_length = 10,default='#bcbcbc')
 

forum/forms.py
from django import forms
from .models import Post, Color, Comment, ReplyComment
from forum.models import KATEGORI

class PostForm(forms.ModelForm):
    class Meta:
        model = Post
        fields = ["judul", "kategori", "isi"]
    
    input_judul = {
        'type' : 'text',
        'placeholder' : 'Title Discussion',
        'class' : 'form-control',
        'autocomplete' : 'off'
    }
    
    input_kategori = {
        'type' : 'text',
        'placeholder' : 'Category Discussion',
        'class' : 'form-control arrow'
    }
    
    input_isi = {
        'type' : 'text',
        'placeholder' : 'Write Here',
        'class' : 'form-control'
    }
    
    judul = forms.CharField(label='', required=True, max_length=150, widget=forms.TextInput(attrs=input_judul))
    kategori = forms.ChoiceField(label='', choices=KATEGORI, widget=forms.Select(attrs=input_kategori))
    isi = forms.CharField(label='', required=True, widget=forms.Textarea(attrs=input_isi))

class CommentForm(forms.ModelForm):
    class Meta:
        model = Comment
        fields = ["isi"]
 
    input_isi = {
        'type' : 'text',
        'placeholder' : 'Write Here',
        'class' : 'form-control',
        'autocomplete' : 'off',
        'rows' : 3,
    }
    
    isi = forms.CharField(label='', required=True, widget=forms.Textarea(attrs=input_isi))

    
class ReplyCommentForm(forms.ModelForm):
    class Meta:
        model = ReplyComment
        fields = ["isi"]
    
    input_isi = {
        'type' : 'text',
        'placeholder' : 'Reply Here',
        'class' : 'form-control',
        'autocomplete' : 'off',
        'rows' : 3,
    }
    
    isi = forms.CharField(label='', required=True, widget=forms.Textarea(attrs=input_isi))
    
    

forum/views.py
from django.http import HttpResponseRedirect, HttpResponse, JsonResponse
from rest_framework.serializers import Serializer
from django.shortcuts import get_object_or_404, redirect, render
from .forms import PostForm, CommentForm, ReplyCommentForm
from django.contrib.auth.decorators import login_required
from django.views.decorators.csrf import csrf_exempt
from .models import Post, Comment, ReplyComment, Color
from authentication.models import Profile
from django.contrib.auth.models import User
from django.core import serializers
import json 

def forum(request, category=None):
    num_posts = Post.objects.all().count()
    num_users = User.objects.all().count()
    colorProfile = Color.objects.all()
    
    if request.user.is_authenticated and category == 'user' :
        diskusi = Post.objects.filter(penulis = request.user).order_by('-DateTime')
    elif category != 'all' and category:
        diskusi = Post.objects.filter(kategori = category).order_by('-DateTime')
    else:
        diskusi = Post.objects.all().order_by('-DateTime')
        
    if category==None:
        category = 'all'
        
    return render(request, 'forum/mainForum.html',{
        "num_posts":num_posts,
        'category' : category,
        "num_users":num_users,
        'diskusi' : diskusi, 
        'colorProfile' : colorProfile, 
    })


def profil(request, username):
    num_posts = Post.objects.all().count()
    num_users = User.objects.all().count()
    #check if user exist
    filterUser = User.objects.filter(username = username)
    
    if filterUser:
        user = User.objects.get(username = username)

        #check if user already have color profile
        filter = Color.objects.filter(user = user)
        
        diskusi = Post.objects.filter(penulis = user).order_by('-DateTime')
        colorProfile = Color.objects.all()
        
        if filter:
            warna = Color.objects.get(user = user)
        
        if request.user == user:
            if not filter:
                warna = Color(user = user)
                
            if request.POST and form.is_valid():
                print(request.POST)
                
                posts = Post.objects.all()
                for post in posts:
                    tempWarna = Color.objects.get(user = post.penulis)
                    post.warna = tempWarna.colorHex
                    post.save()
                return HttpResponseRedirect(request.path_info)
            
        if not filter:
            warna = None
        
        return render(request, 'forum/profil.html', {
            "num_posts":num_posts,
            "num_users":num_users,
            'userInProfil' : user, 
            'warna' : warna, 
            'diskusi' : diskusi, 
            'colorProfile' : colorProfile
        })


@login_required(login_url='/accounts/login')
def editPost(request, pk = None):
    'pk is the attribute that contains the value of the primary key for the model.'
    if pk:
        post = get_object_or_404(Post, pk=pk)
    else:
        post = Post(penulis = request.user)

    # Create a form instance with POST data.
    form = PostForm(request.POST or None, instance = post)
    if request.POST and form.is_valid():
        print(request.POST)
        # Save the new instance.
        form.save()
        current_user = Profile.objects.get(user=request.user)
        warna = Color.objects.filter(user = request.user)
        if not warna:
            warna = Color(
                colorHex = current_user.profil_color,
                user = request.user
            )
            warna.save()
        
        temp = Post.objects.last()
        tempWarna = Color.objects.get(user = temp.penulis)
        temp.warna = tempWarna.colorHex
        print(temp.warna)
        lststr = [temp.judul,temp.penulis.username,temp.isi]
        temp.strings = ' '.join(lststr) 
        temp.namaPenulis = temp.penulis.username
        temp.save()

        return redirect('forum:forum1')

    context = {'form': form}
    return render(request, 'forum/editPost.html',context)
   

def readForum(request, pk = None):
    diskusi = get_object_or_404(Post, pk = pk)
    komen = Comment.objects.filter(post = diskusi).order_by('DateTime')
    reply = ReplyComment.objects.all().order_by('DateTime')

    if request.user.is_authenticated:
        komenForForm = Comment(penulis = request.user, post = diskusi)
        form = CommentForm(request.POST or None, instance = komenForForm)
        if request.POST and form.is_valid():
            print(request.POST)
            form.save()
            
            kom = Comment.objects.last()
            kom.namaPenulis = kom.penulis.username
            kom.warna = Color.objects.get(user = kom.penulis).colorHex
            kom.jumlahReply = 0
            kom.save()
            
            return HttpResponseRedirect(request.path_info)
    else:
        form = None
        
    colorProfile = Color.objects.all()
    return render(request, 'forum/readForum.html',{
        'diskusi' : diskusi, 
        'komen' : komen, 
        'reply' : reply, 
        'form' : form, 
        'colorProfile' : colorProfile
    })




@login_required(login_url='/accounts/login')
def editComment(request, pk = None):
    if request.user.is_authenticated:
    
        komen = get_object_or_404(Comment, pk=pk)
                
        form = CommentForm(request.POST or None, instance = komen)
        if request.POST and form.is_valid():
            print(request.POST)
            form.save()
            return redirect('forum:readForum', komen.post.pk)
        
        colorProfile = Color.objects.all()
        return render(request, 'forum/editComment.html',{
            'form': form,
            'diskusi' : komen.post,
            'komen' : komen,
            'type' : 'edit',
            'colorProfile' : colorProfile
        })


@login_required(login_url='/accounts/login')
def editReply(request, pkC = None, pkR = None):
    target = None
    
    if not pkC and pkR:
        target = get_object_or_404(ReplyComment, pk=pkR)
        komen = target.komen
    else:
        komen = get_object_or_404(Comment, pk=pkC)

    if pkC and pkR:
        reply = get_object_or_404(ReplyComment, pk=pkR)
        target = reply
        type = 'edit'
    else:
        reply = ReplyComment(penulis = request.user, komen = komen)
        type = 'add'

    form = ReplyCommentForm(request.POST or None, instance = reply)
    if request.POST and form.is_valid():
        print(request.POST)
        form.save()
        if type == 'add':
            rep = ReplyComment.objects.last()
            rep.namaPenulis = rep.penulis.username
            rep.warna = Color.objects.get(user = rep.penulis).colorHex
            rep.save()
            kom = rep.komen
            kom.jumlahReply = int(kom.jumlahReply) + 1
            kom.save()
        return redirect('forum:readForum', komen.post.pk)
    
    # target
    if target != None:
        replyTo = [target]
        while target.targetBalasan != None:
            replyTo.append(target.targetBalasan)
        replyTo.reverse()
    else:
        replyTo = None
    
    colorProfile = Color.objects.all()
    
    context = {
        'form': form,
        'komen' : komen,
        'replyTo' : replyTo,
        'type' : type,
        'colorProfile' : colorProfile
    }
    return render(request, 'forum/editComment.html', context)
    
    
def confirmDeletePost(request, pk = None):
    if request.user.is_authenticated:
        post = get_object_or_404(Post, pk=pk)
        colorProfile = Color.objects.all()
        return render(request, 'forum/confirmDelete.html', {
            'diskusi':post, 
            'colorProfile' : colorProfile
        })
    

def deletePost(request, pk = None):
    if request.user.is_authenticated:
        post = Post.objects.filter(pk=pk)
        post.delete()
        return redirect('forum:forum1')
    
    
def confirmDeleteComment(request, pk = None):
    if request.user.is_authenticated:
        comment = get_object_or_404(Comment, pk=pk)
        colorProfile = Color.objects.all()
        
        return render(request, 'forum/confirmDelete.html', {
            'komen':comment, 
            'colorProfile' : colorProfile
        })


def deleteComment(request, pk = None):
    if request.user.is_authenticated:
        komen = Comment.objects.filter(pk=pk)
        post = komen[:1].get().post
        komen.delete()
        return redirect('forum:readForum', post.pk)
      

def confirmDeleteReply(request, pk = None):
    if request.user.is_authenticated:
        colorProfile = Color.objects.all()
        target = get_object_or_404(ReplyComment, pk=pk)
        reply = target
        komen = reply.komen
        
        #target
        if target != None:
            replyTo = [target]
            while target.targetBalasan != None:
                target = target.targetBalasan
                replyTo.append(target) 
        else:
            replyTo = None

        return render(request, 'forum/confirmDelete.html', {
            'reply':reply, 
            'komen':komen, 
            'replyTo':replyTo, 
            'colorProfile' : colorProfile
        })
    


def deleteReply(request, pk = None):
    if request.user.is_authenticated:
        reply = ReplyComment.objects.filter(pk=pk)
        post = reply[:1].get().komen.post
            
        kom = reply[:1].get().komen
        print(kom)
        reply.delete()
        
        count = 0
        allReply = ReplyComment.objects.all()
        for reply in allReply:
            if reply.komen == kom:
                count = count + 1
        kom.jumlahReply = count
        kom.save()
        
        return redirect('forum:readForum', post.pk)
    

def search(request, category = None): 
    if category == 'user':
        diskusi = Post.objects.filter(penulis = request.user).order_by('-DateTime')
    elif category != 'all' and category:

forum/templates/forum/editPost.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Create Forum</title>
<link rel="stylesheet" href="{% static 'forum/css/styles.css' %}">
{% endblock meta %}

{% block content %}
    <div class="container" style="margin-bottom:110px;">
            <div>
                <p class="title">Discussion</p>
                <p class="subtitle">by {{ user.username }}</p>
            </div>
            <div class="form">
                <form method="POST">
                    {% csrf_token %}
                    {{ form.as_p }}
                    <div class="leftright center">
                        <button type="submit" class="button1" id="bodyButton">Post to Forum</button>
                        <button href="#" onclick="history.back();return false" type="cancel" class="button2" id="bodyButton">Cancel</button>
                    </div>
                </form>
            </div>
    </div>
{% endblock content %}

forum/templates/forum/readForum.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
    <title>Read Forum {{ diskusi.judul }}</title>
    <link rel="stylesheet" href="{% static 'forum/css/styles.css' %}">
    <link rel="stylesheet" href="//code.jquery.com/ui/1.13.0/themes/base/jquery-ui.css">
    <script src="https://code.jquery.com/jquery-3.6.0.js"></script>
    <script src="https://code.jquery.com/ui/1.13.0/jquery-ui.js"></script>
    <script type="application/javascript" src="{% static 'forum/js/showReplies.js' %}"></script>
    
{% endblock meta %}

{% block content %}
    <div class="container" id="readForum" style="margin-bottom:110px; overflow-y:auto;">
            <div style="padding-bottom: 20px; padding-top: 20px;">
                <a href="{% url 'forum:forum1' %}" class="back">&lt Back to Forum</a>
            </div>        
        <div class="topdown">

            <div class="topdown insidereadpost center">
                <div class="profile-container text-center">
                    <div class="profile" 
                        {% for warna in colorProfile %}
                            {% if warna.user == diskusi.penulis %} 
                            style="background-color: {{warna.colorHex}};"
                            {% endif %}
                        {% endfor %}>
                        <div class="center inisial">
                            {{ diskusi.penulis|make_list|first|upper }}
                        </div>
                    </div>
                </div> 

                <div class="topdown snippet fontall b">
                    <div style="font-weight: bold; font-size: 20px;" class="text-center">
                        {{ diskusi.judul }} <br>
                    </div>
                    <span class="subJudulPost text-center" >
                        <a href="{% url 'forum:forum2' diskusi.kategori %}" 
                            {% if diskusi.kategori == 'general' %} class="tipe1"
                            {% elif diskusi.kategori == 'covid' %} class="tipe2"
                            {% elif diskusi.kategori == 'drug' %} class="tipe3"
                            {% endif %}>
                            
                            {% if diskusi.kategori == 'general' %} [General Discussion]
                            {% elif diskusi.kategori == 'covid' %} [Covid Info]
                            {% elif diskusi.kategori == 'drug' %} [Drug Info]
                            {% endif %}
                        </a> 
                            by 
                        <a href="{% url 'forum:profil' diskusi.penulis.username %}" class="edit"> 
                            {{ diskusi.penulis }} 
                        </a>  on {{ diskusi.DateTime|date:'d-M-Y H:i' }} WIB  
                        {% if diskusi.penulis == request.user %}           
                            <a href="{% url 'forum:editPost' diskusi.pk %}" class="edit"></br> edit </a> | 
                            <a href="{% url 'forum:confirmDeletePost' diskusi.pk %}" class="edit"> delete </a>
                        {% endif %}
                    </span>
                    <div class='b'>
                        {{ diskusi.isi}}
                    </div>
                </div>
            </div>
            <div class='text-center'>
                <div class="topdown" style="width: 100%;"> 
                        {% if user.is_authenticated %}
                        <h4 class="judulPostInside center" style="width: 100%;">
                        Comment Here
                        </h4>
                        <div class="form">
                            <form method="POST">
                                {% csrf_token %}
                                {{ form.as_p }}
                                <div>
                                    <button type="submit" class="button1" id="bodyButton">Post to Forum</button>
                                </div>
                            </form>
                        </div>
                        {% else %} 
                            <h4 class="judulPostInside center" style="width: 100%;">
                                Please Login to Comment
                            </h4>
                            <div class="leftright center" style="height: 60px;">
                                <a href="{% url 'authentication:Login' %}" class="button1 bodyButton" style="font-size: 26px; width: 200px;">Login</a>
                            </div>
                            <p style="font-size: .9rem; margin-top: .5rem;">
                                Don't have an account?
                                <a class="replybutton" href="{% url 'authentication:SignUp' %}">Register here</a>
                            </p>
                        {% endif %}
                        <div class="komen-container">
                            {% if komen %}
                                {% for k in komen %}
                                    <div class="one-komen-container">
                                        <div class="komen">
                                            <div class="replycomment inside-post-komen">
                                                <div class="profile-container-komen">
                                                    <div class="profile-komen" 
                                                    {% for warna in colorProfile %}
                                                        {% if warna.user == k.penulis %} 
                                                            style="background-color: {{warna.colorHex}};"
                                                        {% endif %}
                                                    {% endfor %}>
                                                        <div class="topdown center inisial-komen">
                                                            {{ k.penulis|make_list|first|upper }}
                                                        </div>
                                                    </div>
                                                </div>
                                                <div class="topdown alignitem snippet-komen">
                                                    <div class="leftright headerKomen">
                                                        <div class="judulKomen">
                                                            <a href="{% url 'forum:profil' k.penulis.username %}" class="link-normal">{{ k.penulis }}</a>
                                                        </div>
                                                        <span class="subJudulKomen">
                                                            {{ k.DateTime|date:'d-M-Y H:i' }} WIB
                                                            {% if k.penulis == request.user %} | 
                                                                <a href="{% url 'forum:editComment' k.pk %}" class="edit"> edit </a> | 
                                                                <a href="{% url 'forum:confirmDeleteComment' k.pk %}" class="edit"> delete </a>
                                                            {% endif %}
                                                        </span>
                                                    </div>
                                                    <div class="isiKomen b">
                                                        {{ k.isi }}
                                                    </div>
                                                    <div class="replybutton"><a href="{% url 'forum:addReply' k.pk %}" class="replybutton"> Reply </a></div>
                                                </div>
                                            </div>
                                        </div>

                                        {% if k.jumlahReply != '0' %}
                                            <div class="showReplies">
                                                <div class="showRepliesChild1">
                                                    <p class="openCloseReplyP"> View 
                                                        {%if k.jumlahReply == '1'%}{{ k.jumlahReply }} Reply
                                                        {% else %}{{ k.jumlahReply }} Replies
                                                        {%endif%}
                                                    </p> 
                                                </div>
                                                <div class="showRepliesChild2">
                                                    <i class="arrow up" style="margin: 0px 3px 0px 0px;"></i>
                                                    <p class="openCloseReplyP">Close 
                                                        {%if k.jumlahReply == '1'%}{{ k.jumlahReply }} Reply
                                                        {% else %}{{ k.jumlahReply }} Replies
                                                        {%endif%}
                                                    </p>
                                                </div>
                                            </div>
                                        {% endif %}

                                        <div class="reply-container">
                                            {% if reply %}
                                                {% for r in reply %}
                                                    {% if r.komen == k %}
                                                        <div class="reply">
                                                            <div class="leftright inside-post-komen">
                                                                <div class="profile-container-komen">
                                                                    <div class="profile-komen" 
                                                                        {% for warna in colorProfile %}
                                                                            {% if warna.user == k.penulis %} 
                                                                                style="background-color: {{warna.colorHex}};"
                                                                            {% endif %}
                                                                        {% endfor %}>
                                                                        <div class="topdown center inisial-komen">
                                                                            {{ r.penulis|make_list|first|upper }}
                                                                        </div>
                                                                    </div>
                                                                </div>
                                                                <div class="topdown alignitem snippet-komen">
                                                                    <div class="leftright headerKomen">
                                                                        <div class="judulKomen">
                                                                            <a href="{% url 'forum:profil' r.penulis.username %}" class="link-normal">{{ r.penulis }}</a>
                                                                        </div>
                                                                        <span class="subJudulKomen">
                                                                            {{ r.DateTime|date:'d-M-Y H:i' }} WIB
                                                                            {% if r.penulis == request.user %} | 
                                                                                <a href="{% url 'forum:editReply' k.pk r.pk %}" class="edit"> edit </a> |
                                                                                <a href="{% url 'forum:confirmDeleteReply' r.pk %}" class="edit"> delete </a>
                                                                            {% endif %}
                                                                        </span>
                                                                    </div>
                                                                    <div class="isiKomen b">
                                                                        {{ r.isi |linebreaks}}
                                                                    </div>
                                                                </div>
                                                            </div>
                                                        </div>
                                                    {% endif %}
                                                {% endfor %}
                                            {% endif %}
                                        </div>
                                    </div>
                                {% endfor %}
                            {% endif %}
                        </div>
                </div>
            </div>
        </div>
    </div>
{% endblock content %}